namespace ALingA
{
  class Arc;
  class PrecedingArc;

  class Arcs
  {
  public:
    Arcs();

    Arcs(const Arcs &);

    size_t
    size() const;

    %rename (isEmpty) empty;
    bool
    empty() const;

    void
    clear();

    %extend
    {
      void insert(Arc & arc)
      {
	self->insert(&arc);
      }

      bool erase(Arc & arc)
      {
	std::pair<ALingA::iArcs, ALingA::iArcs> p = self->equal_range(&arc);
	ALingA::iArcs i = p.first;
	for (
	     ;
	     i != p.second
	       ;
	     ++i
	     )
	  {
	    if ( **i == arc )
	      {
		self->erase(i);
		return(true);
	      }
	  }
	return(false);
      }
	
	
      Arc * first() const
      {
	ALingA::iArcs i = self->begin();
	if ( i != self->end() )
	  return(*i);
	else
	  return 0;
      }
      
      Arc * next(Arc & arc) const
      {
	std::pair<ALingA::iArcs, ALingA::iArcs> p = self->equal_range(&arc);
	ALingA::iArcs i = p.first;
	for (
	     ;
	     i != p.second
	       ;
	     ++i
	     )
	  {
	    if ( arc == **i )
	      {
		++i;
		if ( i != self->end() )
		  return(*i);
		else
		  return(0);
	      }
	  }
	if ( i != self->end() )
	  return(*i);
	else
	  return 0;
      }
    }
  };
}
