namespace ALingA
{
  class Node;
  class PrecedingNode;

  class Nodes
  {
  public:
    Nodes();

    Nodes(const Nodes &);

    size_t
    size() const;

    %rename (isEmpty) empty;
    bool
    empty() const;

    void
    clear();

    %extend
    {
      void insert(Node & node)
      {
	self->insert(&node);
      }

      bool erase(Node & node)
      {
	std::pair<ALingA::iNodes, ALingA::iNodes> p = self->equal_range(&node);
	ALingA::iNodes i = p.first;
	for (
	     ;
	     i != p.second
	       ;
	     ++i
	     )
	  {
	    if ( **i == node )
	      {
		self->erase(i);
		return(true);
	      }
	  }
	return(false);
      }
	
	
      Node * first() const
      {
	ALingA::iNodes i = self->begin();
	if ( i != self->end() )
	  return(*i);
	else
	  return 0;
      }
      
      Node * next(Node & node) const
      {
	std::pair<ALingA::iNodes, ALingA::iNodes> p = self->equal_range(&node);
	ALingA::iNodes i = p.first;
	for (
	     ;
	     i != p.second
	       ;
	     ++i
	     )
	  {
	    if ( **i == node )
	      {
		++i;
		if ( i != self->end() )
		  return (*i);
		else
		  return(0);
	      }
	  }
	if ( i != self->end() )
	  return (*i);
	else
	  return(0);
      }
    }
  };
}
